Type GameApp
	Field gw: Int
	Field gh: Int
	Field gamestates: GameState[]
	Field currentgamestate: GameState
	Field currentgamestateid: Int
	Field gamestatecount: Int
	Method init() Abstract
	Method unInit() Abstract
	Method load() Abstract
	Method unLoad() Abstract
	Method run()
		If Not changeGameState(0)
			Return
		End If
		Local fTime: Float = 0
		Local iLasttime: Int = MilliSecs()
		Repeat
			currentgamestate.move(fTime)
			currentgamestate.render(fTime)
			fTime = (MilliSecs()-iLasttime)/1000.0
			iLasttime = MilliSecs()
		Forever
	End Method
	Method play()
		If Not init() Return False
		If Not load()
			unInit()
			Return False
		End If
		run()
		unLoad()
		unInit()
	End Method
	Method changeGameState(id: Int)
		If id = -1
			currentgamestate.unLoad()
			currentgamestate.unInit()
			currentgamestate = Null
			End
		End If
		Local iFound: Int = -1
		Local i: Int
		For i = 0 To gamestatecount-1
			If gamestates[i].getID() = id
				iFound = i
				Exit
			End If
		Next
		If iFound <> -1
			Local newgamestate: GameState = gamestates[iFound]
			If Not newgamestate.init(Self) Return False
			If Not newgamestate.load()
				newgamestate.unInit()
				Return False
			End If
			If currentgamestate <> Null
				currentgamestate.unLoad()
				currentgamestate.unInit()
			End If
			currentgamestate = newgamestate
			Return True
		Else
			Return False
		End If
	End Method
End Type

Type GameState
	Field ga: GameApp
	Field id: Int
	Method render(time: Float) Abstract
	Method move(time: Float) Abstract
	Method init(ga: GameApp) Abstract
	Method unInit() Abstract
	Method load() Abstract
	Method unLoad() Abstract
	Method getID()
		Return id
	End Method
	Method setID(id: Int)
		Self.id = id
	End Method
End Type