Type Asteroid Extends SpaceObject
	Field size: Float
	Field rotspeed: Float
	
	Method New()
		MainGame.solist.add(Self)
	End Method
	
	Method getType: Int()
		Return SOT_ASTEROID
	End Method
	
	Function create: Asteroid(x: Float, y: Float, size: Float, rotation: Float, rotspeed: Float, collisionradius = 0, collisiondamage = 0, health = 0)
		Local a: Asteroid = New Asteroid
		a.x = x
		a.y = y
		a.size = size
		
		a.health = health
		a.collisionradius = collisionradius
		a.collisiondamage = collisiondamage
		
		a.rotation = rotation
		a.rotspeed = rotspeed
		
		Return a
	End Function
	
	Method collisionPossible: Int(o: SpaceObject)
		Return True
	End Method
	
	Method collided(damage: Float)'p: Point)
		health :- damage
	End Method
	
	Method draw(p: Point, wscale: Float, wrotation: Float)
		SetMaskColor 0, 0, 0
		SetBlend MASKBLEND
		SetRotation rotation
		SetScale size*wscale, size*wscale
		
		DrawImage RessourceLoader.asteroidimages[0], p.x+x*wscale, p.y+y*wscale
		
		SetRotation 0
		SetBlend SOLIDBLEND
		SetScale 1, 1
	End Method
	
	Method move(time: Float)
		If health > 0
			rotation = rotation + rotspeed*time
		Else
			health = 0
			collisionradius = 1
			collisiondamage = 0
		End if
	End Method
	
	Method destroy()
		Rem
		size :/ 2
		If size > 0.1
			Asteroid.create(x+Rnd(-size*128, size*128), y+Rnd(-size*128, size*128), size/2, rotation, rotspeed, 120*size, 10, 1)
			Asteroid.create(x+Rnd(-size*128, size*128), y+Rnd(-size*128, size*128), size/2, rotation, rotspeed, 120*size, 10, 1)
		End If
		End rem
		Explosion.create(x, y, 30, 1, 500*size)
	End Method
End Type
