Function TileScaled(img: TImage, x: Float, y: Float)
	Local scalex: Float, scaley: Float
	GetScale(scalex, scaley)
	
	Local originx: Float, originy: Float
	GetOrigin(originx, originy)
	
	Assert (scalex > 0) Or (scaley > 0) Else "Scale lower or equal 0!"
	
	Local width: Float = ImageWidth(img)*scalex
	Local height: Float = ImageWidth(img)*scaley
	
	Local startx: Float = x Mod width - originx + (originx Mod width) - width
	Local starty: Float = y Mod height - originy + (originy Mod height) - height
	
	If startx > -originx
		startx :- width
	End If
	
	If starty > -originy
		starty :- height
	End If
	
	Local maxx: Int = GraphicsWidth()-originx
	Local maxy: Int = GraphicsHeight()-originy
	
	Assert (height > 0) Or (width > 0) Else "Width or Height lower or equal 0!"
	
	x = startx
	While x < maxx
		y = starty
		While y < maxy
			DrawImage(img, x, y)
			y :+ height
		Wend
		x :+ width
	Wend
End Function
