Type MainGame Extends GameState
	Field bg: TImage
	Field playership: Ship
	Field renderx: Int, rendery: Int
	Field renderscale: Float
	Field renderrotation: Float
	
	Field radarrotation: Float
	
	Field fpsupdate: Float
	Field fps: Int
	
	Global solist: SpaceObjectList
	
	Method New()
		id = 1
		renderscale = 1
		solist = New SpaceObjectList
	End Method
	
	Method render(time: Float)
		SetOrigin ga.gw/2, ga.gh/2
		SetScale renderscale, renderscale
		TileScaled(bg, renderx*renderscale, rendery*renderscale)
		SetScale 1, 1
		
		Local p: Point = Point.create(renderx*renderscale, rendery*renderscale)
		solist.draw(p, renderscale, renderrotation)
		
		SetBlend ALPHABLEND
		
		DrawImage RessourceLoader.crosshairimage, 0, 0
		
		SetOrigin 0, 0
		
		SetColor 0, 255, 0
		DrawImage RessourceLoader.radarimages[0], 51, ga.gh-51
		SetRotation(radarrotation)
		DrawImage RessourceLoader.radarimages[1], 51, ga.gh-51
		SetRotation 0
		DrawImage RessourceLoader.hudimages[0], ga.gw/2-150, ga.gh-50
		
		Local tx: Int, ty: Int, twidth: Int, theight: Int
		
		GetViewport(tx, ty, twidth, theight)
		
		' Speed
		SetViewport(ga.gw/2-144, ga.gh-4-Ceil(42*(playership.speedacc.speed/playership.speedacc.maximum)), 21, 42*Ceil((playership.speedacc.speed/playership.speedacc.maximum)))
		SetColor 255, 0, 0
		DrawImage RessourceLoader.hudimages[1], ga.gw/2-144, ga.gh-46
		
		' Turbo
		SetColor 0, 255, 0
		SetScale -1, 1
		SetViewport(ga.gw/2+123, ga.gh-4-Ceil(42*(0.5)), 21, 42*(0.5))
		DrawImage RessourceLoader.hudimages[1], ga.gw/2+144, ga.gh-46
		SetScale 1, 1
		
		' Health
		SetViewport(ga.gw/2-119, ga.gh-36, 238*(playership.health/playership.maxhealth), 8)
		SetColor 255, 0, 255
		DrawImage RessourceLoader.hudimages[2], ga.gw/2-119, ga.gh-36
		
		' Shield
		SetViewport(ga.gw/2-119, ga.gh-24, 238*(playership.shieldhealth/playership.maxshield), 8)
		SetColor 0, 255, 255
		DrawImage RessourceLoader.hudimages[2], ga.gw/2-119, ga.gh-24
		
		' Energy
		SetViewport(ga.gw/2-119, ga.gh-12, 238*(playership.energy/playership.maxenergy), 8)
		SetColor 255, 255, 0
		DrawImage RessourceLoader.hudimages[2], ga.gw/2-119, ga.gh-12
		
		SetViewport(tx, ty, twidth, theight)
		SetColor 255, 255, 255
		SetBlend SOLIDBLEND
		
		Local hp: Int = playership.health
		DrawText "FPS: "+FPS, 0, 0
		
		Flip
	End Method
	
	Method move(time: Float)
		radarrotation :+ time*100
		
		solist.move(time)
		If KeyHit(KEY_ESCAPE)	ga.changegamestate(-1)
		If KeyDown(KEY_RIGHT)	playership.rotateRight(time)
		If KeyDown(KEY_LEFT)	playership.rotateLeft(time)
		If KeyDown(KEY_UP)		playership.speedUp(time)
		If KeyDown(KEY_DOWN)	playership.speedDown(time)
		If KeyDown(KEY_SPACE)	playership.shoot()
		renderscale = 1-playership.speedacc.speed/1250
		
		renderx = -playership.x-cos(playership.rotation)* (playership.speedacc.speed/playership.speedacc.maximum*ga.gh/2)/renderscale
		rendery = -playership.y-sin(playership.rotation)* (playership.speedacc.speed/playership.speedacc.maximum*ga.gh/2)/renderscale
		
		fpsupdate :+ time
		If fpsupdate > 1
			fps = (1/time)
			fpsupdate :- 1
		End if
	End Method
	
	Method init(ga: GameApp)
		Self.ga = ga
		renderrotation = 0
		Return True
	End Method
	
	Method unInit()
	End Method
	
	Method load()
		bg = LoadImage("starfield.png")
		If bg = Null Return False
		playership = Ship.create(0, 0, -90, ..
															1000, 2000, 1000, 30, ..
															1000, 500, 200, ..
															500, 1000, 1000, ..
															1000, 50, 1)
		Local size: Float
		For Local i=0 To 100
			size = Rnd(0.1, 1)
			Asteroid.create(Rand(-10000, 10000), Rand(-10000, 10000), size, Rnd(0, 360), Rnd(0, 50), 120*size, 10, 1000*size)
		Next
		
		For Local i=0 To 9
			Local enemyship: Ship = Ship.create(Rand(-10000, 10000), Rand(-10000, 10000), Rand(0, 360), ..
									1000, 1000, 1000, 30, ..
									1000, 0, 200, ..
									500, 1000, 1000, ..
									100, 50, 1)
			enemyship.speedacc.speed = Rand(100, 1000)
			If Rand(0, 1) = 1
				enemyship.rotacc.speed = Rand(-200, -10)
			Else
				enemyship.rotacc.speed = Rand(10, 200)
			End if
		Next
		
		Return True
	End Method
	
	Method unLoad()
	End Method
End Type
