Type Shield Extends OwnerSpark
	Method move(time: Float)
		If alpha > 0
			x = owner.x
			y = owner.y

			alpha = alpha - lifetime*time
		Else
			health = 0
			collisionradius = 1
			collisiondamage = 0
		End if
	End Method
	
	Method getType: Int()
		Return SOT_SHIELD
	End Method
	
	Function create: Shield(owner: SpaceObject, x: Float, y: Float, xscale: Float, yscale: Float, r: int, g: int, b: int, lifetime: Float, rot: Float, speed: Float, collisionradius: Float = 0, collisiondamage: Float = 0, health: Float = 0)
		Local sp:Shield = New Shield
		
		sp.x = x
		sp.y = y
		
		sp.owner = owner
		
		sp.xscale = xscale
		sp.yscale = yscale
		
		sp.xd = Cos(rot) * speed
		sp.yd = Sin(rot) * speed
		
		sp.rotation = rot
		
		sp.lifetime = lifetime
		
		sp.r = r
		sp.g = g
		sp.b = b
		
		sp.collisiondamage = collisiondamage
		sp.collisionradius = collisionradius
		sp.health = health
		
		sp.alpha = 1
		
		Return sp
	End Function
End Type
