Const SOT_SHIP = 1
Const SOT_ASTEROID = 2
Const SOT_SPARK = 3
Const SOT_OWNERSPARK = 4
Const SOT_LASER = 5
Const SOT_SHIELD = 6

Type SpaceObject Abstract
	Field x: Float, y: Float
	Field rotation: Float
	Field collisionradius: Float
	Field collisiondamage: Float
	Field health: Float
	
	Method draw(p: Point, wscale: Float, wrotation: Float) Abstract
	Method move(time: Float) Abstract
	Method destroy() Abstract
	Method collisionPossible: Int(o: SpaceObject) Abstract
	Method collided(damage: Float) Abstract 'p: Point
	
	Method getType: Int() Abstract
	
	Function Collide(o1: SpaceObject, o2: SpaceObject)
		If o1.collisionradius <= 0 Or o2.collisionradius <= 0 Return
		If Not o1.collisionPossible(o2) Then Return
		If Not o2.collisionPossible(o1) Then Return
		Local radius = o1.collisionradius+o2.collisionradius
		radius = radius*radius
		If ((o1.x-o2.x)*(o1.x-o2.x) + (o1.y-o2.y)*(o1.y-o2.y)) <= radius
			'o1.health :- o2.collisiondamage
			'o2.health :- o1.collisiondamage
			'Local cp = Point.create((o1.collisionradius*(o2.x-o1.x))/(o1.collisionradius+o2.collisionradius)+o1.x, ..
			'												(o1.collisionradius*(o2.y-o1.y))/(o1.collisionradius+o2.collisionradius)+o1.y)
			While (o1.health > 0) And (o2.health > 0)
				o1.collided(o2.collisiondamage)'cp)
				o2.collided(o1.collisiondamage)'cp)
			Wend
		End If
	End Function
End Type

Type SpaceObjectList
	Field list: TList
	Method New()
		list = New TList
	End Method
	Method add(so: SpaceObject)
		list.AddLast(so)
	End Method
	Method draw(p: Point, wscale: Float, wrotation: Float)
		For Local so: SpaceObject = EachIn list
			so.draw(p, wscale, wrotation)
			?DEBUG
			If DEBUGKOLLISION
				SetColor 255, 0, 0
				DrawOval p.x+(so.x-so.collisionradius)*wscale, p.y+(so.y-so.collisionradius)*wscale, 2*so.collisionradius*wscale, 2*so.collisionradius*wscale
				SetColor 255, 255, 255
			End If
			?
		Next
	End Method
	Method move(time: Float)
		Local so: SpaceObject
		Local so2: SpaceObject
		Local link: TLink
		Local link2: TLink
		link = list.FirstLink()
		While link <> Null
			so = (SpaceObject)(link.Value())
			so.move(time)
			
			link2 = link.NextLink()
			While link2 <> Null
				so2 = (SpaceObject)(link2.Value())
				SpaceObject.Collide(so, so2)
				link2 = link2.NextLink()
			Wend
			
			If so.health <= 0 And so.collisionradius > 0
				so.destroy()
				list.remove(so)
			End If
			
			link = link.NextLink()
		Wend
	End Method
End Type
